#include "extras.lua"
#include "particles.lua"
#include "shake.lua"
#include "ufo.lua"
#include "projectile.lua"

internalConfig = {
    theme = {
        colorChoices = {
            {r=0, g=1, b=0},
            {r=1, g=1, b=0},
            {r=0, g=1, b=1},
        },
    }
}
config = {
    theme = {
        color = internalConfig.theme.colorChoices[
            math.random(1, #internalConfig.theme.colorChoices)],
    },
    controls = {
        action_1 = "usetool",
        action_2 = "grab",
    },
}

--Called at the beginning
function init()
    RegisterTool("abductizer", "Abductizer", "MOD/vox/model.vox", 6)
    SetBool("game.tool.abductizer.enabled", true)

    --Sounds
    hoverSnd = LoadLoop("MOD/snd/ufo_hover.ogg")
    beamSnd = LoadLoop("MOD/snd/ufo_tractorbeam.ogg")
    motorSnd = LoadLoop("MOD/snd/motor.ogg")
    beamBegin = LoadSound("MOD/snd/ufo_beam_begin.ogg")
    beamEnd = LoadSound("MOD/snd/ufo_beam_end.ogg")
    destroySnd = LoadSound("MOD/snd/ufo_destroy.ogg")
    signalSnd = LoadSound("MOD/snd/signal.ogg")
    signalEndSnd = LoadSound("MOD/snd/signal_end.ogg")

    --Sprites
    beamSprite = LoadSprite("MOD/sprite/tractorbeam.png")
    signalSprite = LoadSprite("MOD/sprite/signal.png")
    ufoSprite = LoadSprite("MOD/sprite/ufo.png")
    arrowSprite = LoadSprite("MOD/sprite/arrow.png")
end
--Called every frame
function tick(dt)
    tickUfo(dt)
    tickSignalEndAnimations(dt)

    --If tool is being used continue
    if GetString("game.player.tool") ~= "abductizer" then return end
    if not GetBool("game.player.canusetool") then return end

    tickTool(dt)

    --Process shaking if needed
    processShake(dt)
end
--Beam particles
function update(dt)
    updateSignals(dt)
    ufoUpdate(dt)
end
--Draws UI
function draw()
    drawUfoCallOffTimer()
end
